package sialocacao.alocacao.servlets;


import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import sialocacao.*;

import sialocacao.alocacao.*;
import sialocacao.professor.*;
import sialocacao.sala.*;
import sialocacao.disciplina.*;
import sialocacao.util.Data;

/**
 * <p>Title: SIAlocacao</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author fabrica03
 * @version 1.0
 */

public class ServletEditarAlocacao extends HttpServlet{
  public void doGet( HttpServletRequest req,
                     HttpServletResponse res )
    throws ServletException, IOException{

    doPost(req, res);
  }

  public void doPost( HttpServletRequest req,
                      HttpServletResponse res )
    throws ServletException, IOException{

    boolean desalocar =
      req.getParameter("desalocar") != null;

    int codProfessor =
      Integer.parseInt( req.getParameter( "professor" ) );
    int codDisciplina =
      Integer.parseInt( req.getParameter( "disciplina" ) );
    int codSala =
      Integer.parseInt( req.getParameter( "sala" ) );
    int codHorario =
      Integer.parseInt( req.getParameter( "horario" ) );

    Data data = new Data(req.getParameter("data"));
    try{
      SIAlocacao sialocacao =
        new SIAlocacao();

       Professor professor = new Professor();
       professor.setCodigo(codProfessor);
       Horario horario = new Horario();
       horario.setCodigo(codHorario);
       Sala sala =new Sala();
       sala.setCodigo(codSala);

       Disciplina disciplina = new Disciplina();
       disciplina.setCodigo(codDisciplina);

       Alocacao alocacao =
         sialocacao.getAlocacao(sala, horario, data);

      if(desalocar){

        sialocacao.excluirAlocacao(alocacao.getCodigo());

        res.sendRedirect("/sialocacao/mapaAlocacao.jsp?semana=atual&mensagem=Alocao removida com "+
        "sucesso!");

        return;
      }

      /*if(professor==null) {
        res.sendRedirect("/sialocacao/mapaAlocacao.jsp?semana=atual&mensagem=ERRO! No foi "+
         "possvel fazer a alocao! (disciplina no tem professor associado)");

        return;
      }*/

      alocacao.setCodProfessor(professor.getCodigo());
      alocacao.setCodDisciplina(codDisciplina);
      System.out.println("hein1");
      sialocacao.alterarAlocacao(alocacao);
      System.out.println("hein2");
      res.sendRedirect("/sialocacao/mapaAlocacao.jsp?semana=atual&mensagem=Alocao alterada com "+
        "sucesso!");

      return;
      }catch(SIAlocacaoException ex){ex.printStackTrace();
           res.sendRedirect("/sialocacao/mapaAlocacao.jsp?semana=atual&mensagem=ERRO! No foi "+
           "possvel fazer a alocao! ("+ex.getDescription()+")");

           return;
      }catch(Exception ex){ex.printStackTrace();
       res.sendRedirect("/sialocacao/mapaAlocacao.jsp?semana=atual&mensagem=ERRO! No foi "+
       "possvel fazer a editar a alocao!");

       return;
     }

  }
}