package sialocacao.professor.servlets;


import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

import sialocacao.*;
import sialocacao.alocacao.*;

/**
 * <p>Title: SIAlocacao</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author fabrica03
 * @version 2.0
 */

public class ServletCadastrarProfessor extends HttpServlet{
  public void doGet( HttpServletRequest req,
                     HttpServletResponse res )
    throws ServletException, IOException{

    doPost(req, res);
  }

  public void doPost( HttpServletRequest req,
                      HttpServletResponse res )
    throws ServletException, IOException{

    String nome = req.getParameter( "nome" );
    String cpf = req.getParameter( "cpf" );
    String[] peso =
      req.getParameterValues("peso");

    try{
      SIAlocacao sialocacao =
        new SIAlocacao();

      sialocacao.inserirProfessor(nome, cpf);

      Iterator horarios =
        sialocacao.listarHorarios().iterator();

      int codProfessor =
        sialocacao.buscarProfessor(nome).getCodigo();

      for(int i=0; i<peso.length; i++){
        sialocacao.inserirHorariosProfessor(codProfessor,
          ((Horario)horarios.next()).getCodigo(),
          Integer.parseInt(peso[i]));
      }

      res.sendRedirect("/sialocacao/index.jsp?mensagem=Professor "+
        "inserido com sucesso!");

      return;
    }catch(Exception ex){ex.printStackTrace();
       res.sendRedirect("/sialocacao/index.jsp?mensagem=ERRO! No foi "+
       "possvel inserir o professor!");

       return;
     }
  }
}