package sialocacao.disciplina.servlets;


import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;

import sialocacao.*;
import sialocacao.disciplina.*;

public class ServletAssociarProfessorDisciplina extends HttpServlet{

  public void doGet( HttpServletRequest req, HttpServletResponse res )
    throws ServletException, IOException{

    doPost(req, res);
  }

  public void doPost( HttpServletRequest req, HttpServletResponse res )
    throws ServletException, IOException{

    String associa = req.getParameter("associar");

    if(associa == null) {
       res.sendRedirect("/sialocacao/alocacao.jsp");
       return;
    }

    String[] professor = req.getParameterValues("professor");

    HttpSession sessao = req.getSession(true);

    try {

      SIAlocacao sialocacao = new SIAlocacao();

      List disciplinas = sialocacao.listarDisciplinas();

      Iterator iterator = disciplinas.iterator();
      Disciplina disciplina = null;
      int index = 0, codProfessor = 0;

      while(iterator.hasNext()) {
        disciplina = (Disciplina)iterator.next();
        codProfessor = Integer.parseInt(professor[index]);
        sialocacao.associaProfessorDisciplina(disciplina, codProfessor);
        index ++;
      }

      res.sendRedirect("/sialocacao/alocacao.jsp?mensagem=Associao de disciplina "+
        "com professor inserida com sucesso!");

      return;
    } catch(Exception ex){
       res.sendRedirect("/sialocacao/alocacao.jsp?mensagem=ERRO! No foi "+
       "possvel associar disciplina a professor!");

       return;
    }
  }
}