package sialocacao.disciplina.servlets;


import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import sialocacao.sala.Categoria;

import sialocacao.*;

public class ServletCadastrarDisciplina extends HttpServlet{
  public void doGet( HttpServletRequest req,
                     HttpServletResponse res )
    throws ServletException, IOException{

    doPost(req, res);
  }

  public void doPost( HttpServletRequest req,
                      HttpServletResponse res )
    throws ServletException, IOException{

    String descricao = req.getParameter( "descricao" );
    int cargaHoraria = Integer.parseInt( req.getParameter( "cargaHoraria" ) );
    String ementa = req.getParameter( "ementa" );

    HttpSession sessao = req.getSession(true);
    List categorias = (List)sessao.getAttribute("categorias");
    Map prioridades = new HashMap();
    for(int i=0; i<categorias.size(); i++) {
        String codCategoria = ((Categoria)categorias.get(i)).getCodigo()+"";
        String codPreferencia = req.getParameter("preferencia_"+codCategoria);
        prioridades.put(codCategoria, codPreferencia);
    }

    try{
      SIAlocacao sialocacao =
        new SIAlocacao();
      sialocacao.inserirDisciplina(descricao, cargaHoraria, ementa, prioridades);

      res.sendRedirect("/sialocacao/index.jsp?mensagem=Disciplina "+
        "inserida com sucesso!");

      return;
    }catch(Exception ex){ex.printStackTrace();
       res.sendRedirect("/sialocacao/index.jsp?mensagem=ERRO! No foi "+
       "possvel inserir a disciplina!");

       return;
     }
  }
}