package sialocacao.sala.database;

/**
 * <p>Title: ISalaDatabase.java </p>
 * <p>Description: Interface da classe ISalaDatabase. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */

import java.util.*;

import sialocacao.*;
import sialocacao.sala.*;
import sialocacao.sala.excecoes.*;

public interface ICategoriaDatabase {

  /*
   * Lista categorias do sistema.
   * @return ArrayList
   */
  public ArrayList listarCategorias() throws SIAlocacaoException,
      CategoriaInexistenteException;
}
