<%@ page buffer="128kb" %>
<%@ page import="java.util.*" %>

<%@ page import="sialocacao.*" %>
<%@ page import="sialocacao.alocacao.*" %>
<%@ page import="sialocacao.sala.*" %>
<%@ page import="sialocacao.disciplina.*" %>
<%@ page import="sialocacao.util.*" %>

<%!
  SIAlocacao sialocacao = new SIAlocacao();
%>

<%

  Collection horarios = (Collection)session.getAttribute("listahorarios");
  Collection salas = null;
  Map horariosSessao = (Map)session.getAttribute("horarios");
  try{


    if(horariosSessao == null) {
        horariosSessao = new HashMap();
        session.setAttribute("horarios", horariosSessao);
    }

    if(horarios == null) {
        horarios = sialocacao.listarHorarios();
        session.setAttribute("listahorarios", horarios);
    }

    salas = sialocacao.listarSalas();

  }catch(Exception e){
  	e.printStackTrace();
     response.sendRedirect("/sialocacao/index.jsp?mensagem=No foi possvel acessar banco de dados. Acesse"+
	   " novamente mais tarde!");
	 return;
   }

   String semana = (String)request.getParameter("semana");
   Data data = (Data)session.getAttribute("data");
   if(semana== null || data==null) {
      data = new Data();
      session.setAttribute("data", data);
   }

   if(semana != null && semana.equals("proxima")) {
       data = data.getProximaData(7);
       session.setAttribute("data", data);
   } else if(semana != null && semana.equals("anterior")) {
       data = data.getProximaData(-7);
       session.setAttribute("data", data);
   }


   Data dataSeg = data.getProximaData(2-GregorianCalendar.getInstance().get(GregorianCalendar.DAY_OF_WEEK));
   Data dataTer = dataSeg.getProximaData(1);
   Data dataQua = dataTer.getProximaData(1);
   Data dataQui = dataQua.getProximaData(1);
   Data dataSex = dataQui.getProximaData(1);
   Data dataSab = dataSex.getProximaData(1);

%>


<html>
<head>

<title>SIAloca&ccedil;&atilde;o</title>

<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="links.css" rel="stylesheet" type="text/css">
<script src="funcoes.js"></script>
</head>
<body bgcolor="#FFFFFF" topmargin = "0" leftmargin = "0" link="#FFFFFF" vlink="#FFFFFF" alink="#FFFFFF" >

<%@ include file="cabecalho.txt" %>

  <tr>
    <td colspan="2" > <!-- #BeginEditable "conteudo" -->
	  <%
	    List conflitos =
		  (ArrayList)session.getAttribute("conflitos");
		 
		session.removeAttribute("conflitos");
	  %>	  
      <p align="center"><br>
        <font face="Arial, Helvetica, sans-serif"><b><font color="#FF0000"><%= request.getParameter("mensagem") != null ? request.getParameter("mensagem"): ""%></font></b></font>
      </p>
	  <p align="center"><br>
        <font face="Arial, Helvetica, sans-serif"><b><font color="#FF0000"><%= conflitos != null && conflitos.size() != 0 ? "Os seguintes conflitos foram encontrados!!!": ""%></font></b></font>
      </p>
	  <% 
		 if(conflitos != null && conflitos.size() != 0){
		   for(int i=0; i<conflitos.size(); i++){
	  %> 
	  <p align="center"><br>
        <font face="Arial, Helvetica, sans-serif"><b><font color="#FF0000"><%= (String)conflitos.get(i) %></font></b></font>
      </p>
	  <% 
	      } // end for
		 }  //end if
	  %>
      <br>
      <p align="center"><br>
      <div align="center"><br>
        <% if(semana!=null && !data.equals(new Data())) { %>
        <a href="/sialocacao/mapaAlocacao.jsp?semana=anterior"><font color="#990000" size="2" face="Verdana, Arial, Helvetica, sans-serif"><b>
        semana anterior</b></font></a>
        <% } %>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        <a href="/sialocacao/mapaAlocacao.jsp?semana=proxima"><font color="#990000" size="2" face="Verdana, Arial, Helvetica, sans-serif"><b>
        prxima semana</b></font></a>
      </div>
       </p>
      <table width="100%" border="0" class="tabela">
        <tr class="lsListaTabela">
          <td width="10%" rowspan="2" >
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>Hor&aacute;rios</b></font></div>
          </td>
          <td width="10%" rowspan="2" >
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>Salas</b></font></div>
          </td>
          <td colspan="6" >
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>Dias
              da semana</b></font></div>
          </td>
        </tr>
        <tr class="lsListaTabela">
          <td width="13%" >
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>Seg, <%=dataSeg%></b></font></div>
          </td>
          <td width="13%" >
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>Ter, <%=dataTer%></b></font></div>
          </td>
          <td width="13%" >
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>Qua, <%=dataQua%></b></font></div>
          </td>
          <td width="13%" >
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>Qui, <%=dataQui%></b></font></div>
          </td>
          <td width="13%" >
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>Sex, <%=dataSex%></b></font></div>
          </td>
          <td width="14%" >
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>S&aacute;b, <%=dataSab%></b></font></div>
          </td>
        </tr>
        <%
		Iterator itHorarios = horarios.iterator();


        Set horariosCadastrados = new HashSet();

	    int numLinha = 1;

		int numSalas  = salas.size();
		while (itHorarios.hasNext()){
           Horario horario = (Horario)itHorarios.next();

           if(!horariosCadastrados.contains(horario)){
              horariosCadastrados.add(horario);
/*
           if(!horariosCadastrados.contains(horario.getHoraInicio()+":"+horario.getHoraFim())){
              horariosCadastrados.add(horario.getHoraInicio()+":"+horario.getHoraFim());
*/
%>
        <tr class=<%=(numLinha%2==0?"liListaTabela1":"liListaTabela2")%> align="center">
          <td width="10%" valign="middle" rowspan="<%=numSalas%>">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><%=horario.getHoraInicio()%><br>
              <%=horario.getHoraFim()%> </font></div>
          </td>
		  <%
		    Iterator itSalas = salas.iterator();
			Sala sala =null;
			Horario horarioSeg = null, horarioTer = null, horarioQua = null, horarioQui = null, horarioSex = null, horarioSab = null;
			Disciplina disciplinaSeg = null, disciplinaTer = null, disciplinaQua = null, disciplinaQui = null, disciplinaSex = null, disciplinaSab = null;
		    String segunda = Horario.SEGUNDA, terca = Horario.TERCA, quarta = Horario.QUARTA, quinta = Horario.QUINTA, sexta = Horario.SEXTA, sabado = Horario.SABADO;
			if (itSalas.hasNext()){
			  sala = (Sala)itSalas.next();

			  try{
			  	horarioSeg = sialocacao.buscarHorario(segunda, horario.getHoraInicio(), horario.getHoraFim());
                                horariosSessao.put(""+horarioSeg.getCodigo(), horarioSeg);
				disciplinaSeg = sialocacao.getDisciplinaAlocada(sala, horarioSeg, dataSeg);

				horarioTer = sialocacao.buscarHorario(terca, horario.getHoraInicio(), horario.getHoraFim());
                                horariosSessao.put(""+horarioTer.getCodigo(), horarioTer);
				disciplinaTer = sialocacao.getDisciplinaAlocada(sala, horarioTer, dataTer);

				horarioQua = sialocacao.buscarHorario(quarta, horario.getHoraInicio(), horario.getHoraFim());
                                horariosSessao.put(""+horarioQua.getCodigo(), horarioQua);
				disciplinaQua = sialocacao.getDisciplinaAlocada(sala, horarioQua, dataQua);

				horarioQui = sialocacao.buscarHorario(quinta, horario.getHoraInicio(), horario.getHoraFim());
                                horariosSessao.put(""+horarioQui.getCodigo(), horarioQui);
				disciplinaQui = sialocacao.getDisciplinaAlocada(sala, horarioQui, dataQui);

				horarioSex = sialocacao.buscarHorario(sexta, horario.getHoraInicio(), horario.getHoraFim());
                                horariosSessao.put(""+horarioSex.getCodigo(), horarioSex);
				disciplinaSex = sialocacao.getDisciplinaAlocada(sala, horarioSex, dataSex);

				horarioSab = sialocacao.buscarHorario(sabado, horario.getHoraInicio(), horario.getHoraFim());
                                horariosSessao.put(""+horarioSab.getCodigo(), horarioSab);
				disciplinaSab = sialocacao.getDisciplinaAlocada(sala, horarioSab, dataSab);

			  }catch(Exception e){
			    	e.printStackTrace();
				 response.sendRedirect("/sialocacao/index.jsp?mensagem=" + e.getMessage());
				 return;
			   }
		  %>
          <td width="6%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">
             <%=sala.getDescricao()%></font></div>
          </td>
          <td width="13%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br>
		<%
			if (disciplinaSeg != null) {
		%>
 <a href="/sialocacao/editar_alocacao.jsp?codHorario=<%=horarioSeg.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataSeg%>">
 <font color="#990000"> <b><%=disciplinaSeg.getDescricao()%></b></font></a>
			<%	} else {
			%>
 <a href="/sialocacao/fazer_alocacao.jsp?codHorario=<%=horarioSeg.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataSeg%>">
 <font color="#990000"> <b>Alocar</b></font></a>
		 <%		} // fim do else
		 %>
</font></div>
          </td>
          <td width="13%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br>
		<%
			if (disciplinaTer != null) {
		%>
 <a href="/sialocacao/editar_alocacao.jsp?codHorario=<%=horarioTer.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataTer%>">
 <font color="#990000"> <b><%=disciplinaTer.getDescricao()%></b></font></a>
			<%	} else {
			%>
<a href="/sialocacao/fazer_alocacao.jsp?codHorario=<%=horarioTer.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataTer%>">
<font color="#990000"> <b>Alocar</b></font></a>
		 <%		} // fim do else
		 %>
</font></div>
          </td>
          <td width="13%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br>
		<%
			if (disciplinaQua != null) {
		%>
<a href="/sialocacao/editar_alocacao.jsp?codHorario=<%=horarioQua.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataQua%>">
<font color="#990000"> <b><%=disciplinaQua.getDescricao()%></b></font></a>
			<%	} else {
			%>
<a href="/sialocacao/fazer_alocacao.jsp?codHorario=<%=horarioQua.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataQua%>">
<font color="#990000"> <b>Alocar</b></font></a>
		 <%		} // fim do else
		 %>
</font></div>
          </td>
          <td width="13%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br>
		<%
			if (disciplinaQui != null) {
		%>
<a href="/sialocacao/editar_alocacao.jsp?codHorario=<%=horarioQui.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataQui%>">
<font color="#990000"> <b><%=disciplinaQui.getDescricao()%></b></font></a>
			<%	} else {
			%>
<a href="/sialocacao/fazer_alocacao.jsp?codHorario=<%=horarioQui.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataQui%>">
<font color="#990000"> <b>Alocar</b></font></a>
		 <%		} // fim do else
		 %>
</font></div>
          </td>
          <td width="13%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br>
		<%
			if (disciplinaSex != null) {
		%>
<a href="/sialocacao/editar_alocacao.jsp?codHorario=<%=horarioSex.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataSex%>">
<font color="#990000"> <b><%=disciplinaSex.getDescricao()%></b></font></a>
			<%	} else {
			%>
<a href="/sialocacao/fazer_alocacao.jsp?codHorario=<%=horarioSex.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataSex%>">
<font color="#990000"> <b>Alocar</b></font></a>
		 <%		} // fim do else
		 %>
</font></div>
          </td>
          <td width="14%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br>
		<%
			if (disciplinaSab != null) {
		%>
<a href="/sialocacao/editar_alocacao.jsp?codHorario=<%=horarioSab.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataSab%>">
<font color="#990000"> <b><%=disciplinaSab.getDescricao()%></b></font></a>
			<%	} else {
			%>
<a href="/sialocacao/fazer_alocacao.jsp?codHorario=<%=horarioSab.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataSab%>">
<font color="#990000"> <b>Alocar</b></font></a>
		 <%		} // fim do else
		 %>
</font></div>
          </td></tr>
		  <%
		  	} // fim do if para iterar primeira sala
			while (itSalas.hasNext()){
			  sala = (Sala)itSalas.next();
			  try{
				disciplinaSeg = sialocacao.getDisciplinaAlocada(sala, horarioSeg, dataSeg);

				disciplinaTer = sialocacao.getDisciplinaAlocada(sala, horarioTer, dataTer);

				disciplinaQua = sialocacao.getDisciplinaAlocada(sala, horarioQua, dataQua);

				disciplinaQui = sialocacao.getDisciplinaAlocada(sala, horarioQui, dataQui);

				disciplinaSex = sialocacao.getDisciplinaAlocada(sala, horarioSex, dataSex);

				disciplinaSab = sialocacao.getDisciplinaAlocada(sala, horarioSab, dataSab);

			  }catch(Exception e){
			    	e.printStackTrace();
				 response.sendRedirect("/sialocacao/index.jsp?mensagem=" + e.getMessage());
				 return;
			   }

		  %>
        <tr class=<%=(numLinha%2==0?"liListaTabela1":"liListaTabela2")%> align="center">
          <td width="6%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">
             <%=sala.getDescricao()%></font></div>
          </td>
          <td width="13%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br>
		<%
			if (disciplinaSeg != null) {
		%>
<a href="/sialocacao/editar_alocacao.jsp?codHorario=<%=horarioSeg.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataSeg%>">
<font color="#990000"> <b><%=disciplinaSeg.getDescricao()%></b></font></a>
			<%	} else {
			%>
<a href="/sialocacao/fazer_alocacao.jsp?codHorario=<%=horarioSeg.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataSeg%>">
<font color="#990000"> <b>Alocar</b></font></a>
		 <%		} // fim do else
		 %>
</font></div>
          </td>
          <td width="13%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br>
		<%
			if (disciplinaTer != null) {
		%>
<a href="/sialocacao/editar_alocacao.jsp?codHorario=<%=horarioTer.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataTer%>">
<font color="#990000"> <b><%=disciplinaTer.getDescricao()%></b></font></a>
			<%	} else {
			%>
<a href="/sialocacao/fazer_alocacao.jsp?codHorario=<%=horarioTer.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataTer%>">
<font color="#990000"> <b>Alocar</b></font></a>
		 <%		} // fim do else
		 %>
</font></div>
          </td>
          <td width="13%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br>
		<%
			if (disciplinaQua != null) {
		%>
<a href="/sialocacao/editar_alocacao.jsp?codHorario=<%=horarioQua.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataQua%>">
<font color="#990000"> <b><%=disciplinaQua.getDescricao()%></b></font></a>
			<%	} else {
			%>
<a href="/sialocacao/fazer_alocacao.jsp?codHorario=<%=horarioQua.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataQua%>">
<font color="#990000"> <b>Alocar</b></font></a>
		 <%		} // fim do else
		 %>
</font></div>
          </td>
          <td width="13%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br>
		<%
			if (disciplinaQui != null) {
		%>
<a href="/sialocacao/editar_alocacao.jsp?codHorario=<%=horarioQui.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataQui%>">
<font color="#990000"> <b><%=disciplinaQui.getDescricao()%></b></font></a>
			<%	} else {
			%>
<a href="/sialocacao/fazer_alocacao.jsp?codHorario=<%=horarioQui.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataQui%>">
<font color="#990000"> <b>Alocar</b></font></a>
		 <%		} // fim do else
		 %>
</font></div>
          </td>
          <td width="13%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br>
		<%
			if (disciplinaSex != null) {
		%>
<a href="/sialocacao/editar_alocacao.jsp?codHorario=<%=horarioSex.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataSex%>">
<font color="#990000"> <b><%=disciplinaSex.getDescricao()%></b></font></a>
		<%	} else {
		%>
<a href="/sialocacao/fazer_alocacao.jsp?codHorario=<%=horarioSex.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataSex%>">
<font color="#990000"> <b>Alocar</b></font></a>
	 <%		} // fim do else
	 %>
</font></div>
          </td>
          <td width="14%">
            <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br>
		<%
			if (disciplinaSab != null) {
		%>
<a href="/sialocacao/editar_alocacao.jsp?codHorario=<%=horarioSab.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataSab%>">
<font color="#990000"> <b><%=disciplinaSab.getDescricao()%></b></font></a>
		<%	} else {
		%>
<a href="/sialocacao/fazer_alocacao.jsp?codHorario=<%=horarioSab.getCodigo()%>&codSala=<%=sala.getCodigo()%>&data=<%=dataSab%>">
<font color="#990000"> <b>Alocar</b></font></a>
	 <%		} // fim do else
	 %>
</font></div>
          </td>
</tr>
		  <%
		} // fim do while para iterar demais salas
		numLinha++;
    } // fim do if para ver se o horario ja foi listado
  } // fim do while para iterar horrios
          %>
      </table>
      <div align="center"><br>
        <a href="/sialocacao/alocacao.jsp"><font color="#990000" size="2" face="Verdana, Arial, Helvetica, sans-serif"><b>&lt;
        Voltar</b></font></a> </div>
      <!-- #EndEditable --></td>
  </tr>
</table>
<p><b><blink></blink></b> </p>
<p>&nbsp;</p>
<p align="center"><b><blink></blink></b></p>
<p align="center"><b><blink></blink></b></p>
<div align="left"> </div>
<p align="center" style="margin-top: 0; margin-bottom: 0">&nbsp;</p>
<div align="left"> </div>

</body>
<!-- #EndTemplate --></html>
